﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace AddingNewItemToSpecificRow
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            ViewModel vm = new ViewModel();
            InitializeComponent();
            DataContext = vm;
           
        }

        //private void Button_Click(object sender, RoutedEventArgs e)
        //{
        //    var currentView = ((((sender as Button).Parent as Grid).Children[0] as XamDataGrid).DataContext as ViewModel);
        //    ObservableCollection<Person> c = new ObservableCollection<Person>();
        //    c = currentView.GridData.SourceCollection as ObservableCollection<Person>;
        //    Random r = new Random();
           

        //    if ((((sender as Button).Parent as Grid).Children[0] as XamDataGrid).ActiveRecord != null)
        //    {
        //        int activerecordIndex = (((sender as Button).Parent as Grid).Children[0] as XamDataGrid).ActiveRecord.Index;
        //        if ((activerecordIndex + 1) < c.Count)
        //        {
        //            c.Insert(activerecordIndex + 1, new Person("Test" + r.Next(1, 100), "Test" + r.Next(200, 300)));
        //        }
        //        else
        //        {
        //            c.Add(new Person("Test" + r.Next(1, 100), "Test" + r.Next(200, 300)));   
        //        }
        //    }
        //}
       
       
    }


    public class ViewModel : INotifyPropertyChanged
    {
        public ViewModel()
        {
            ObservableCollection<Person> CollectionData = new ObservableCollection<Person>();
            CollectionData = Person.GetPeople();
           GridData = new ListCollectionView(CollectionData);
        
        }

        public ICommand AddItem
        {
            get
            {
                return new RelayCommand<object>(
                    new Action<object>(
                        (obj) =>
                        {
                            var o = obj;
                            var currentView = ((((o as Button).Parent as Grid).Children[0] as XamDataGrid).DataContext as ViewModel);
                            ObservableCollection<Person> collection = new ObservableCollection<Person>();
                            collection = currentView.GridData.SourceCollection as ObservableCollection<Person>;
                            Random r = new Random();


                            if ((((o as Button).Parent as Grid).Children[0] as XamDataGrid).ActiveRecord != null)
                            {
                                int activerecordIndex = (((o as Button).Parent as Grid).Children[0] as XamDataGrid).ActiveRecord.Index;
                                if ((activerecordIndex + 1) < collection.Count)
                                {
                                    collection.Insert(activerecordIndex + 1, new Person("Test" + r.Next(1, 100), "Test" + r.Next(200, 300)));
                                }
                                else
                                {
                                    collection.Add(new Person("Test" + r.Next(1, 100), "Test" + r.Next(200, 300)));
                                }
                            }
                        }

                ));
            }
        }

        private  ICollectionView _gridData;

        public ICollectionView GridData
        {
            get { return _gridData; }
            set
            {
                _gridData = value;
                RaisePropertyChanged("GridData");
            }
        }

         public event PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new global::System.ComponentModel.PropertyChangedEventArgs(propertyName));
            }
        }
    }

    public class Person : INotifyPropertyChanged
    {
        #region FirstName (INotifyPropertyChanged Property)
        private string _firstName;

        public string FirstName
        {
            get { return _firstName; }
            set
            {
                _firstName = value;
                RaisePropertyChanged("FirstName");
            }
        }
        #endregion
        #region LastName (INotifyPropertyChanged Property)
        private string _lastName;

        public string LastName
        {
            get { return _lastName; }
            set
            {
                _lastName = value;
                RaisePropertyChanged("LastName");
            }
        }
        #endregion
     

        public static ObservableCollection<Person> GetPeople()
        {
           ObservableCollection<Person> source = new ObservableCollection<Person>();

            source.Add(new Person("Jack", "Sparrow"));
            source.Add(new Person("Hulk", "Hulk"));
            source.Add(new Person("Cat", "Woman"));
            //source.Add(new Person("Frodo", "Baggins"));
            //source.Add(new Person("Luke", "Skywalker"));

            return source;
        }

        public static ObservableCollection<Person> GetPeople(int number)
        {
            ObservableCollection<Person> source = new global::System.Collections.ObjectModel.ObservableCollection<Person>();

            for (int i = 0; i < number; i++)
            {
                int age = new Random(i).Next(10, 70);
                source.Add(new Person(RandomString(5), RandomString(7), age, age % 2 == 0 ? Genders.Male : Genders.Female));
            }
            return source;
        }

        public Person()
        {
            this.FirstName = "New First Name";
            this.LastName = "New Last Name";
        }

        public Person(string firstName, string lastName)
        {
            this.FirstName = firstName;
            this.LastName = lastName;
        }

        public Person(string firstName, string lastName, int age)
        {
            this.FirstName = firstName;
            this.LastName = lastName;
        }

        public Person(string firstName, string lastName, int age, Genders gender)
        {
            this.FirstName = firstName;
            this.LastName = lastName;

        }

        public Person(string firstName, string lastName, int age, Genders gender, List<object> interests)
        {
            this.FirstName = firstName;
            this.LastName = lastName;

        }

        #region INotifyPropertyChanged values

        public event global::System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        #endregion

        public enum Genders
        {
            Male, Female
        }
        private static string RandomString(int size)
        {
            StringBuilder builder = new StringBuilder();
            Random seed = new Random((int)DateTime.Now.Millisecond);
            System.Threading.Thread.Sleep(1);
            Random random = new Random(seed.Next(0, 1000));
            char ch;
            for (int i = 0; i < size; i++)
            {
                ch = Convert.ToChar(Convert.ToInt32(Math.Floor(26 * random.NextDouble() + 65)));
                builder.Append(ch);
            }
            return builder.ToString();
        }
    }

    public class RelayCommand<T> : ICommand
    {

        #region Declarations

        readonly Predicate<T> _canExecute;
        readonly Action<T> _execute;

        #endregion

        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="RelayCommand&lt;T&gt;"/> class and 
        /// the command can always be executed.
        /// </summary>
        /// <param name="execute">The execution logic.</param>
        public RelayCommand(Action<T> execute)
            : this(execute, null)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RelayCommand&lt;T&gt;"/> class.
        /// </summary>
        /// <param name="execute">The execution logic.</param>
        /// <param name="canExecute">The execution status logic.</param>
        public RelayCommand(Action<T> execute, Predicate<T> canExecute)
        {

            if (execute == null)
                throw new ArgumentNullException("execute");
            _execute = execute;
            _canExecute = canExecute;
        }

        #endregion

        #region ICommand Members

        public event EventHandler CanExecuteChanged
        {
            add
            {

                if (_canExecute != null)
                    CommandManager.RequerySuggested += value;
            }
            remove
            {

                if (_canExecute != null)
                    CommandManager.RequerySuggested -= value;
            }
        }



        [DebuggerStepThrough]
        public virtual Boolean CanExecute(Object parameter)
        {
            return _canExecute == null ? true : _canExecute((T)parameter);
        }

        public virtual void Execute(Object parameter)
        {
            _execute((T)parameter);
        }



        #endregion
    }
}
